#pragma once
#include "DarkFrame.h"
#include "FlatFrame.h"

class CMemoryBitmap;
class CStackingInfo;
namespace DSS { class ProgressBase; }
class CMasterFrames
{
private :
	std::shared_ptr<CMemoryBitmap> m_pMasterOffset;
	CDarkFrame m_MasterDark;
	CFlatFrame m_MasterFlat;
	bool m_fDebloom;

public :
	CMasterFrames();
	virtual ~CMasterFrames() = default;

	void ApplyMasterOffset(std::shared_ptr<CMemoryBitmap> pBitmap, DSS::ProgressBase * pProgress);
	void ApplyMasterDark(std::shared_ptr<CMemoryBitmap> pBitmap, const STARVECTOR*, DSS::ProgressBase* pProgress);
	void ApplyMasterFlat(std::shared_ptr<CMemoryBitmap> pBitmap, DSS::ProgressBase* pProgress);
	void ApplyHotPixelInterpolation(std::shared_ptr<CMemoryBitmap> pBitmap, DSS::ProgressBase* pProgress);
	void ApplyAllMasters(std::shared_ptr<CMemoryBitmap> pBitmap, const STARVECTOR* pStars, DSS::ProgressBase* pProgress);

	bool LoadMasters(const CStackingInfo* pStackingInfo, DSS::ProgressBase* pProgress);
};
